unit Vraag2_UMemo;
// Oplossing vir vraag 2

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, Math;

type
  TfrmVraag2 = class(TForm)
    grpLenings: TGroupBox;
    redV2: TRichEdit;
    cboAansoekers: TComboBox;
    pnlVerlaat: TPanel;
    bmbVerlaat: TBitBtn;
    lblRentekoers: TLabel;
    edtRenteKoers: TEdit;
    btnVindAansoeker: TButton;
    btnEvalueer: TButton;
    grpAansoekStatus: TGroupBox;
    grpAansoekers: TGroupBox;
    cboJare: TComboBox;
    lblJare: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnEvalueerClick(Sender: TObject);
    procedure btnVindAansoekerClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraag2: TfrmVraag2;

implementation

uses
  HuisLening_UMemo;

const
  iAantalJare = 25;

var
   LeningObj : THuisLening;

{$R *.dfm}
{$R+}

procedure TfrmVraag2.btnVindAansoekerClick(Sender: TObject);
var
  sAansoekerNaam, sLeerNaam: String;
  rInkomste, rUitgawes, rLening, rBesteeInkomste: real;
  TLeer : Textfile;
  sNaam : String;
begin
  // Vraag 2.2.1.
  if  cboAansoekers.ItemIndex = -1
   then
    begin
      MessageDlg('Kies  ''n aansoeker', mtError, [mbOk], 0);
      Exit;
    end
   else
    begin
      sAansoekerNaam := cboAansoekers.Items[cboAansoekers.ItemIndex];
      sLeernaam := sAansoekerNaam + '.txt';
    end;

  redV2.Lines.Clear;
  if NOT FileExists(sLeerNaam)
   then
    begin
       redV2.Lines.Add('Geen huisleningaansoek is  deur ' + sAansoekerNaam + ' ingedien nie.');
       btnEvalueer.Enabled := False;
       Exit;
    end;
  AssignFile(TLeer, sLeernaam);
  Reset(TLeer);
  Readln(TLeer, sNaam);
  Readln(TLeer, rInkomste);
  Readln(TLeer, rUitgawes);
  Readln(TLeer, rLening);
  CloseFile(TLeer);
  redV2.Lines.Add('''n Huisleningaansoek is ingedien deur ' + sAansoekerNaam);
  rBesteeInkomste := rInkomste - rUitgawes;
  LeningObj := THuisLening.Create(sAansoekerNaam, rBesteeInkomste, rLening);
  MessageDlg('Huisleningobjek is suksesvol geskep', mtInformation, [mbOk],0);
  btnEvalueer.Enabled := true;
end;
//======================================================================
procedure TfrmVraag2.btnEvalueerClick(Sender: TObject);
var
  rRentekoers : real;
  iJare       : integer;
begin
  // Vraag 2.2.2
  iJare := StrToInt(cboJare.Items[cboJare.ItemIndex]);
  rRentekoers := StrToFloat(edtRenteKoers.Text);

  LeningObj.SetJare(iJare);
  LeningObj.SetRentekoers(rRentekoers);

  redV2.Lines.Clear;
  if LeningObj.isGoedgekeur
   then
    begin
      redV2.Lines.Add(LeningObj.toString + #13 +
         'Lening GOEDGEKEUR met ''n maandelikse paaiement van R ' +
         FloatToStrF(LeningObj.berekenPaaiement, ffFixed, 8, 2));
    end
   else
    begin
      redV2.Lines.Add('Naam van aansoeker: ' + LeningObj.GetAansoekerNaam + #13 +
                      'Lening NIE GOEDGEKEUR NIE');
    end;
end;
//======================================================================
procedure TfrmVraag2.FormCreate(Sender: TObject);
begin
  CurrencyString := 'R ';
// cboAansoekers.ItemIndex := 0;
end;

end.
